/*
	NodePingPong
	semplice esempio di utilizzo di Net e Node
*/

import java.io.* ;
import NetNode.* ;

public class NodePingPong extends Node {
    String pingpong ;
    String destNode ;
    PingPongProcess P ;
    
    public NodePingPong( String pp, String dest, String name, String host, int port ) 
            throws IOException {
        super( name, host, port ) ;
        pingpong = pp ;
        destNode = dest ;
    }
    
    public void startNode() {
        P = new PingPongProcess( this, pingpong, destNode ) ;
        P.start() ;
    }
    
    public void handleMessage( NodeMessage m ) {
        P.takeMessage( m ) ;
    }
    
    public static void main( String args[] ) throws IOException {
        if ( args.length < 5 || args.length > 5 ) {
            System.err.println( "Uso : NodePingPong (PING|PONG) dest name host port" ) ;
            System.exit(1) ;
        }
            
        NodePingPong n = new NodePingPong( args[0], args[1], args[2], args[3],
            Integer.parseInt( args[4] ) ) ;
        n.start() ;
    }               
}

class PingPongProcess extends Thread {
    Node parentNode ;
    String pingpong ;
    String answer ;
    String destNode ;
    
    public PingPongProcess( Node n, String pp, String dest ) {
        parentNode = n ;
        pingpong = pp ;
        if ( pp.equals( "PING" ) )
            answer = new String( "PONG" ) ;
        else
            answer = new String( "PING" ) ;
        destNode = dest ;
    }
    
    public void run() {
        if ( pingpong.equals( "PING" ) )
            parentNode.sendMessage( destNode, 0, pingpong ) ;
        // while ( true ) {
            waitForAnswer() ;
        //}
    }
    
    synchronized protected void waitForAnswer() {
        try {
            wait() ;
            // attende un po'
            Thread.sleep( 1000 ) ;
            parentNode.sendMessage( destNode, 0, pingpong ) ;
        } catch ( InterruptedException e ) {
            e.printStackTrace() ;
        }
    }
    
    synchronized public void takeMessage( NodeMessage message ) {
        if ( ((String)message.Content).equals( answer ) )
            notify() ;
    }
}
        
            